<template>
  <div class="modal-container" id="optConfirmModal">
    <div class="modal-header">
      <p class="title">{{ $t('otp.removeOtp.title') }}</p>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="form-group">
        <input name="password"
          v-validate="'required'"
          @keyup.enter="verifyCode"
          type="password"
          @focus="resetError"
          v-model="password"
          data-vv-validate-on="none"
          :placeholder="$t('otp.removeOtp.placeholder.password')"
        >
        <span class="invalid-feedback" v-if="errors.has('password')">
          {{ errors.first('password') }}
        </span>
      </div>
      <div class="form-group">
        <input name="code"
          v-validate="'required|length:6'"
          @keyup.enter="verifyCode"
          data-vv-as="OTP code"
          type="text"
          @focus="resetError"
          maxlength="6"
          @keypress="isNumber"
          v-model="code"
          data-vv-validate-on="none"
          :placeholder="$t('otp.removeOtp.placeholder.code')"
        >
        <span class="invalid-feedback" v-if="errors.has('code')">
          {{ errors.first('code') }}
        </span>
      </div>
      <div class="text-center">
        <button type="button" class="btn btn-submit" @click="verifyCode">{{ $t('otp.btnSubmit') }}</button>
      </div>
    </div>
  </div>
</template>
<script>
import { mapMutations } from 'vuex';

import OtpInputMixin from '../../../common/components/Otp/OtpInputMixin';
import rf from '../../../common/requests/RequestFactory';

export default {
  data () {
    return {
      code: '',
      password: '',
    };
  },
  mixins: [OtpInputMixin],
  methods: {
    ...mapMutations([
      'updateUser',
    ]),
    closeModal () {
      this.$broadcast('close-modal');
    },
    verifyCode () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            code: this.code,
            password: this.password,
          };
          rf.getRequest('UserRequest').removeAuthentication(params)
            .then(res => {
              this.updateUser(res.data);
              this.$toasted.show(this.$t('otp.removeOtp.message.success'), {
                theme: 'bubble',
                position: 'top-right',
                duration : 2000,
              });
              this.closeModal();
            })
            .catch((error) => {
              this.errors.clear();
              const errors = error.errors;
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        })
    },
  },
};
</script>
<style lang="scss" scoped>
  @import '../../../../sass/mobile/typoVariables';
  * {
    font-family: $font-family-home;
  }
  #optConfirmModal {
    width: 270rem;
    height: 300rem;
    border-radius: 10px;
    background: $bg_primary;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    margin: auto;
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .title {
        font-size: 16rem;
        font-weight: bold;
        color: #1c1c1c;
        text-align: center;
        line-height: 3.13;
        padding: 31rem 0 10rem;
      }
      .btn-close {
        width: 20rem;
        height: 20rem;
        background-color: #ffffff;
        border: 1px solid #fff;
        border-radius: 50%;
        position: absolute;
        outline: none;
        top: 10rem;
        right: 10px;
        span {
          cursor: pointer;
          color: #989898;
          font-size: 11rem;
        }
      }
    }
    .modal-body {
      margin: 0;
      padding: 0 20rem;
      .form-group {
        text-align: center;
        background: none;
        position: relative;
        padding: 0;
        width: 100%;
        margin-bottom: 20rem;
        input {
          width: 100%;
          height: 40rem;
          border-radius: 74rem;
          background-color: #ffffff;
          border: none;
          font-size: 14rem;
          padding: 0 20rem;
          outline: none;
          &:placeholder {
            color: #cacaca;
          }
        }
      }
      .btn-submit {
        margin-top: 10rem;
        width: 90rem;
        height: 32rem;
        border-radius: 30rem;
        border: solid 1px #fa7300;
        background: #fff;
        font-size: 12rem;
        font-weight: bold;
        font-style: normal;
        font-stretch: normal;
        line-height: normal;
        letter-spacing: 0.5px;
        color: #fa7300;
        outline: none;
        cursor: pointer;
      }
    }

    .invalid-feedback {
      color: red;
      position: absolute;
      text-align: left;
      bottom: -20rem;
      font-size: 11rem;
    }
  }
</style>
